/**************************************************************************
 *    WetPaint 1.2
 *    COPYRIGHT 1993 BY DAVID KOSKI AND GARRICK TOUBASSI
 *    ALL RIGHTS RESERVED
 **************************************************************************/

#import <appkit/appkit.h>
#import "FilterProtocol.h"
#import "FMProtocol.h"
#import "filterLibrary.h"

@interface Filter:Object <Filter>
{
    int			version11;	// Dummy for demo protection

    id <FilterManager>	filterManager;	// The Fm that loaded this filter
    
    NXPoint		pointOffset;
    
    int			red;		// process red channel flag
    int			green;
    int			blue;
    int			alpha;
    int			chan[4];
    
    int			colorSpace;
    
    int			bitsPerPixel, samplesPerPixel, bitsPerSample, isPlanar;
    int			numPlanes, hasAlpha, bytesPerRow;
    int			pixelsWide, pixelsHigh;
    
    unsigned char	*planes[5];
}

- filterWasLoaded:manager;
- filterWillUnload;
- filterImage;
- filterAltImage;
- filterInspector;
- (const char *)filterTitle;
- (const char *)getHelpFile;
- (const char *)getHelpMarker;

- filterActivated:sender;
- filterDeactivated:sender;

- getChannels;
- (unsigned int)whichCommonAttrs;

- (NXBitmapImageRep *)toDepth: (NXWindowDepth) depth :(NXImage *)theImage;
- (NXImage *)drawBitmap:bitmapRep;
- (NXImage *)applyFilter:(NXImage *)theImage;
- (NXImage *)applyFilter:(NXImage *)theImage at:(NXPoint *) point;

- convertColor:(NXColor) c :(int) colorSpace :(unsigned char *) buf;
/* this assumes a 24 bit image! */
- toColorSpace:(NXBitmapImageRep *) im :(int) cs;
- fromColorSpace:(NXBitmapImageRep *) im :(int) cs;

@end
