/**************************************************************************
 *    WetPaint 1.2
 *    COPYRIGHT 1993 BY DAVID KOSKI AND GARRICK TOUBASSI
 *    ALL RIGHTS RESERVED
 **************************************************************************/

//------------------------------------------------------------------------
//	Filter Protocol
//
//	A WetPaint Filter is expected to conform to this protocol
//------------------------------------------------------------------------

#define	COLORSPACE_ATTR	(1 << 0)
#define CHANNEL_ATTR	(1 << 1)
#define	ALL_ATTRS	(~0)
#define	NO_ATTRS	(0)

@protocol Filter

- filterWasLoaded:manager;
- filterWillUnload;
- filterImage;
- filterAltImage;
- filterInspector;
- (const char *)filterTitle;
- (const char *)getHelpFile;
- (const char *)getHelpMarker;

- filterActivated:sender;
- filterDeactivated:sender;

- (NXImage *)applyFilter:(NXImage *)theImage;
- (NXImage *)applyFilter:(NXImage *)theImage at:(NXPoint *) point;

- (unsigned int)whichCommonAttrs;

@end
