/**************************************************************************
 *    WetPaint 1.2
 *    COPYRIGHT 1993 BY DAVID KOSKI AND GARRICK TOUBASSI
 *    ALL RIGHTS RESERVED
 **************************************************************************/

#import "TEMPLATEFILTER.h"

@implementation TEMPLATEFILTER

- filterWasLoaded:manager
{
    filterManager = manager;
    filterBundle = [NXBundle bundleForClass:[self class]];
    
    return self;
}

- filterWillUnload
{
    if (iconImage)
	[iconImage free];
    if (inspectorView)
	[[inspectorView window] free];
	
    return self;
}

- filterImage
{
    if (!iconImage) {
        char	buf[MAXPATHLEN + 1];

	if ([filterBundle getPath:buf forResource:"TEMPLATETIFF" ofType:"tiff"])
	    iconImage = [[NXImage alloc] initFromFile:buf];
    }
    
    return iconImage;
}



- filterInspector
{
    if (!inspectorView) {
        char	buf[MAXPATHLEN + 1];

	if ([filterBundle getPath:buf forResource:"TEMPLATEFILTER" 
	    ofType:"nib"]) {
	    [NXApp loadNibFile:buf owner:self];
	}
    }
    
    return inspectorView;
}

- (unsigned int)whichCommonAttrs
{
    return ALL_ATTRS;
}



//--------------------------------------------------------------------------
//	Image Processing Methods
//--------------------------------------------------------------------------

- (NXImage *)applyFilter:(NXImage *)theImage
{
    NXBitmapImageRep	*im;
    unsigned char	*data;
    
    [self getChannels];
    im = [self toDepth: NX_TwentyFourBitRGBDepth :theImage];
    [self toColorSpace: im : colorSpace];
    data = planes[0];
    
    // process data
    
    [self fromColorSpace: im : colorSpace];
    
    theImage = [self drawBitmap:im];
    [im free];
    return theImage;
}


@end
